###
# #%L
# aiSSEMBLE::Test::MDA::Data Delivery Pyspark
# %%
# Copyright (C) 2021 Booz Allen
# %%
# This software package is licensed under the Booz Allen Public License. All Rights Reserved.
# #L%
###
from abc import ABC


class FloatWithValidationBase(ABC):
    """
    Base implementation of the floatWithValidation dictionary type from PysparkDataDeliveryDictionary.

    GENERATED CODE - DO NOT MODIFY (add your customizations in FloatWithValidation).

    Generated from: templates/data-delivery-data-records/dictionary.type.base.py.vm
    """

    MAX_VALUE: float = float('100.0')
    MIN_VALUE: float = float('12.345')
    SCALE: int = int(3)


    def __init__(self, value: float):
        if value is not None:
            self._value = float(value)
        else:
            self._value = None


    @property
    def value(self) -> float:
        return self._value


    @value.setter
    def value(self, value: float) -> None:
        if value is not None:
            value = float(value)
            self._value = round(value, FloatWithValidationBase.SCALE)
        else:
            self._value = None


    def validate(self) -> None:
        """
        Performs the validation for this dictionary type.
        """
        self.validate_value()


    def validate_value(self) -> None:
        if (self._value is not None) and (self._value > FloatWithValidationBase.MAX_VALUE):
            raise ValueError('FloatWithValidation value of \'%s\' is greater than the maximum value of %s' % (self._value, FloatWithValidationBase.MAX_VALUE))
        if (self._value is not None) and (self._value < FloatWithValidationBase.MIN_VALUE):
            raise ValueError('FloatWithValidation value of \'%s\' is less than the minimum value of %s' % (self._value, FloatWithValidationBase.MIN_VALUE))
